Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT1.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT1.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT1.m	(revision 623)
@@ -1,164 +1,164 @@
-VADPT1	;ALB/MRL/MJK - PATIENT VARIABLES ;1/27/07  15:00
-	;;5.3;Registration;**415,489,516,614,634**;Aug 13, 1993;Build 30
-	; Modified from FOIA VISTA,
-	; Copyright (C) 2007 WorldVistA
-	;
-	; This program is free software; you can redistribute it and/or modify
-	; it under the terms of the GNU General Public License as published by
-	; the Free Software Foundation; either version 2 of the License, or
-	; (at your option) any later version.
-	;
-	; This program is distributed in the hope that it will be useful,
-	; but WITHOUT ANY WARRANTY; without even the implied warranty of
-	; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-	; GNU General Public License for more details.
-	;
-	; You should have received a copy of the GNU General Public License
-	; along with this program; if not, write to the Free Software
-	; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-1	;Demographic [DEM]
-	N W,Z,NODE
-	;
-	; -- name [1 - NM]
-	S VAX=^DPT(DFN,0),@VAV@($P(VAS,"^",1))=$P(VAX,"^")
-	;
-	; -- ssn [2 - SS]
-	S Z=$P(VAX,"^",9) S:Z]"" @VAV@($P(VAS,"^",2))=Z_$S(Z]"":"^"_$E(Z,1,3)_"-"_$E(Z,4,5)_"-"_$E(Z,6,10),1:"")
-	;
-	; -- date of birth [2 - DB]
-	S Z=$P(VAX,"^",3),Y=Z I Y]"" X ^DD("DD") S @VAV@($P(VAS,"^",3))=Z_"^"_Y
-	;
-	; -- age [4 - AG]
-	S W=$S('$D(^DPT(DFN,.35)):"",'^(.35):"",1:+^(.35)) S Y=$S('W:DT,1:W) S:Z]"" @VAV@($P(VAS,"^",4))=$E(Y,1,3)-$E(Z,1,3)-($E(Y,4,7)<$E(Z,4,7))
-	;
-	; Added for VOE to support pediatrics
-	;
-	I @VAV@($P(VAS,"^",4))<2 D  ;IHS/ANMC/CLS 01/20/2005
-	.N X,X1,X2,X3
-	.S X1=$S('$G(^DPT(DFN,.35)):DT,1:+^(.35))
-	.S X2=$P(VAX,"^",3) Q:'X1!('X2)
-	.D ^%DTC S X3=X\365.25,X=$S(X3>2:X3,X<31:X_" DYS",1:X\30_" MOS")
-	.S @VAV@($P(VAS,"^",4))=X Q
-	;
-	; End VOE addition
-	;
-	;
-	; -- expired date [6 - EX]
-	S (Y,Z)=W X:Y]"" ^DD("DD") S:Z]"" @VAV@($P(VAS,"^",6))=Z_"^"_Y
-	;
-	; -- sex [5 - SX]
-	S Z=$P(VAX,"^",2) S:Z]"" @VAV@($P(VAS,"^",5))=Z_"^"_$S(Z="M":"MALE",Z="F":"FEMALE",1:"") K Z
-	;
-	; -- remarks [7 - RE]
-	S @VAV@($P(VAS,"^",7))=$P(VAX,"^",10)
-	;
-	; -- historic race [8 - RA]
-	S Z=$P(VAX,"^",6),@VAV@($P(VAS,"^",8))=Z_$S($D(^DIC(10,+Z,0)):"^"_$P(^(0),"^"),1:"")
-	;
-	; -- religion [9 - RP]
-	S Z=$P(VAX,"^",8),@VAV@($P(VAS,"^",9))=Z_$S($D(^DIC(13,+Z,0)):"^"_$P(^(0),"^"),1:"")
-	;
-	; -- marital status [10 - MS]
-	S Z=$P(VAX,"^",5),@VAV@($P(VAS,"^",10))=Z_$S($D(^DIC(11,+Z,0)):"^"_$P(^(0),"^"),1:"")
-	;
-	; -- ethnicity [11 - ET]
-	S X=0 F Y=1:1 S X=+$O(^DPT(DFN,.06,X)) Q:'X  D
-	.S NODE=$G(^DPT(DFN,.06,X,0)),Z=$P(NODE,"^",1) I Z D
-	..S @VAV@($P(VAS,"^",11),Y)=Z_"^"_$P($G(^DIC(10.2,Z,0)),"^",1)
-	..; -- collection method
-	..S Z=$P(NODE,"^",2) I Z D
-	...S @VAV@($P(VAS,"^",11),Y,1)=Z_"^"_$P($G(^DIC(10.3,Z,0)),"^",1)
-	S @VAV@($P(VAS,"^",11))=Y-1
-	;
-	; -- race [12 - RC]
-	S X=0 F Y=1:1 S X=+$O(^DPT(DFN,.02,X)) Q:'X  D
-	.S NODE=$G(^DPT(DFN,.02,X,0)),Z=$P(NODE,"^",1) I Z D
-	..S @VAV@($P(VAS,"^",12),Y)=Z_"^"_$P($G(^DIC(10,Z,0)),"^",1)
-	..; -- collection method
-	..S Z=$P(NODE,"^",2) I Z D
-	...S @VAV@($P(VAS,"^",12),Y,1)=Z_"^"_$P($G(^DIC(10.3,Z,0)),"^",1)
-	S @VAV@($P(VAS,"^",12))=Y-1
-	Q
-	;
-	; Added for VOE to support pediatrics
-	;
-PAGE	; -- IHS printable age  ;IHS/ITSC/CLS 01/14/2005
-	N X,X1,X2,Y,AUX
-	S X1=$S('$D(^DPT(DFN,.35)):DT,1:+^(.35))
-	S X2=$P(VAX,"^",3) D:X2 ^%DTC:X1 S AUX=X\365.25,X=$S(AUX>2:AUX_" YRS",X<31:X_" DYS",1:X\30_" MOS")
-	S @VAV@($P(VAS,"^",4))=X Q
-	;
-	; End addition for VOE & IHS
-	;
-2	;Other Patient Variables [OPD]
-	N W,Z
-	S VAX=^DPT(DFN,0)
-	;
-	; -- city of birth [1 - BC]
-	S @VAV@($P(VAS,"^",1))=$P(VAX,"^",11)
-	;
-	; -- state of birth [2 - BS]
-	S Z=$P(VAX,"^",12),@VAV@($P(VAS,"^",2))=Z_$S($D(^DIC(5,+Z,0)):"^"_$P(^(0),"^",1),1:"")
-	;
-	; -- occupation [6 - OC]
-	S @VAV@($P(VAS,"^",6))=$P(VAX,"^",7)
-	;
-	; -- names
-	S VAX=$S($D(^DPT(DFN,.24)):^(.24),1:"")
-	S @VAV@($P(VAS,"^",3))=$P(VAX,"^",1) ; father's        [3 - FN]
-	S @VAV@($P(VAS,"^",4))=$P(VAX,"^",2) ; mother's        [4 - MN]
-	S @VAV@($P(VAS,"^",5))=$P(VAX,"^",3) ; mother's maiden [5 - MM]
-	;
-	; -- employment status [7 - ES]
-	S VAX=$S($D(^DPT(DFN,.311)):^(.311),1:""),W="EMPLOYED FULL TIME^EMPLOYED PART TIME^NOT EMPLOYED^SELF EMPLOYED^RETIRED^ACTIVE MILITARY DUTY^UNKNOWN"
-	S Z=$P(VAX,"^",15),@VAV@($P(VAS,"^",7))=Z_$S(Z:"^"_$P(W,"^",Z),1:"")
-	Q
-	;
-3	;Address [ADD]
-	S VABEG=$S($D(VATEST("ADD",9)):VATEST("ADD",9),1:DT),VAEND=$S($D(VATEST("ADD",10)):VATEST("ADD",10),1:DT)
-	I $S($D(VAPA("P")):1,'$D(^DPT(DFN,.121)):1,$P(^(.121),"^",9)'="Y":1,'$P(^(.121),"^",7):1,$P(^(.121),"^",7)>VABEG:1,'$P(^(.121),"^",8):0,1:$P(^(.121),"^",8)<VAEND) S VAX=$S($D(^DPT(DFN,.11)):^(.11),1:""),VAX(1)=0
-	E  S VAX=$S($D(^DPT(DFN,.121)):^(.121),1:""),VAX(1)=1
-	F I=1:1:6 S VAZ=$P(VAX,"^",I),@VAV@($P(VAS,"^",I))=VAZ I I=5,$D(^DIC(5,+VAZ,0)) S VAZ=$P(^(0),"^"),@VAV@($P(VAS,"^",5))=@VAV@($P(VAS,"^",5))_"^"_VAZ
-	S VAZ=$S('VAX(1):$P(VAX,"^",7),1:$P(VAX,"^",11)) S:$D(^DIC(5,+$P(VAX,"^",5),1,+VAZ,0)) VAZ=VAZ_"^"_$P(^(0),"^",1) S @VAV@($P(VAS,"^",7))=VAZ
-	S VAZIP4=$P(VAX,U,12)
-	S @VAV@($P(VAS,U,11))=VAZIP4_$S('$G(VAZIP4):"",($L(VAZIP4)=5):U_VAZIP4,1:U_$E(VAZIP4,1,5)_"-"_$E(VAZIP4,6,9))
-	;DG*5.3*516
-	I $D(^DPT(DFN,.13)) S @VAV@($P(VAS,"^",8))=$P(^(.13),"^",1)
-	I 'VAX(1) G CA
-	S @VAV@($P(VAS,"^",8))=$P(VAX,"^",10)
-	F I=7,8 S VAZ=$P(VAX,"^",I),Y=VAZ X:Y]"" ^DD("DD") S @VAV@($P(VAS,"^",I+2))=VAZ_"^"_Y
-CA	;Confidential Address
-	I '$D(^DPT(DFN,.141)) G Q3
-	N VACAT,VAACT,VAACTDT,VATYP,VATYPNAM,VACAN
-	S VAX=$S($D(^DPT(DFN,.141)):^(.141),1:"")
-	S VAACTDT=$S($D(VAPA("CD")):VAPA("CD"),1:DT)
-	F I=1:1:6 S VAZ=$P(VAX,"^",I),@VAV@($P(VAS,"^",I+12))=VAZ D
-	.I I=5,$D(^DIC(5,+VAZ,0)) S VAZ=$P(^(0),"^"),@VAV@($P(VAS,"^",I+12))=@VAV@($P(VAS,"^",I+12))_"^"_VAZ Q
-	.I I=6,($G(VAZ)]"") S @VAV@($P(VAS,"^",I+12))=@VAV@($P(VAS,"^",I+12))_"^"_$S(($L(VAZ)=5):VAZ,1:$E(VAZ,1,5)_"-"_$E(VAZ,6,9))
-	S VAZ=$P(VAX,"^",11) S:$D(^DIC(5,+$P(VAX,"^",5),1,+VAZ,0)) VAZ=VAZ_"^"_$P(^(0),"^",1) S @VAV@($P(VAS,"^",19))=VAZ
-	F I=7,8 S VAZ=$P(VAX,"^",I),Y=VAZ X:Y]"" ^DD("DD") S @VAV@($P(VAS,"^",I+13))=VAZ_"^"_Y
-	S VABEG=$P(VAX,"^",7),VAEND=$P(VAX,"^",8)
-	S @VAV@($P(VAS,"^",12))=1
-	I 'VABEG!(VABEG>VAACTDT)!(VAEND&(VAEND<VAACTDT)) S @VAV@($P(VAS,"^",12))=0
-	I $D(^DPT(DFN,.14)) D
-	.S VACAN="" F  S VACAN=$O(^DPT(DFN,.14,VACAN)) Q:VACAN=""  D
-	..Q:'$D(^DPT(DFN,.14,VACAN,0))
-	..S VATYP=$P(^DPT(DFN,.14,VACAN,0),"^",1),VAACT=$P(^DPT(DFN,.14,VACAN,0),"^",2)
-	..S VACAT=$$GET1^DID(2.141,.01,"","POINTER","","DGERR")
-	..S VATYPNAM="" F I=1:1 S VATYPNAM=$P(VACAT,";",I) Q:VATYPNAM=""  D
-	...I +VATYPNAM[VATYP S VATYPNAM=$P(VATYPNAM,":",2),@VAV@($P(VAS,"^",22),VATYP)=VATYP_"^"_VATYPNAM_"^"_VAACT
-Q3	K VABEG,VAEND,VAZIP4 Q
-	;
-4	;Other Address [OAD]
-	N VAZIP4
-	I $S('$D(VAOA("A")):1,VAOA("A")<1:1,VAOA("A")>6:1,1:0) S VAX=.21,VAOA("A")=7
-	E  S VAX="."_$P("33^34^211^331^311^25","^",+VAOA("A"))
-	S VAX(1)=VAX,VAX=$S($D(^DPT(DFN,VAX(1))):^(VAX(1)),1:"") I VAX(1)=.25 S VAX=$P(VAX,"^",1)_"^^"_$P(VAX,"^",2,99)
-	S VAX(2)=0 F I=3,4,5,6,7,8 S VAX(2)=VAX(2)+1,@VAV@($P(VAS,"^",VAX(2)))=$P(VAX,"^",I)
-	S @VAV@($P(VAS,"^",7))="",@VAV@($P(VAS,"^",8))=$P(VAX,"^",9),VAX(2)=8
-	F I=1,2 S VAX(2)=VAX(2)+1,@VAV@($P(VAS,"^",VAX(2)))=$P(VAX,"^",I)
-	I "^.311^.25"[("^"_VAX(1)_"^") S @VAV@($P(VAS,"^",10))=""
-	S VAZ=@VAV@($P(VAS,"^",5)) I VAZ,$D(^DIC(5,+VAZ,0)) S VAZ(1)=$P(^(0),"^",1),@VAV@($P(VAS,"^",5))=VAZ_"^"_VAZ(1)
-	S VAZIP4=$P($G(^DPT(DFN,.22)),U,VAOA("A"))
-	S @VAV@($P(VAS,U,11))=VAZIP4_$S('$G(VAZIP4):"",($L(VAZIP4)=5):U_VAZIP4,1:U_$E(VAZIP4,1,5)_"-"_$E(VAZIP4,6,9))
-	Q
+VADPT1 ;ALB/MRL/MJK - PATIENT VARIABLES ;1/27/07  15:00
+ ;;5.3;Registration;**415,489,516,614,634**;Aug 13, 1993;Build 28
+ ; Modified from FOIA VISTA,
+ ; Copyright (C) 2007 WorldVistA
+ ;
+ ; This program is free software; you can redistribute it and/or modify
+ ; it under the terms of the GNU General Public License as published by
+ ; the Free Software Foundation; either version 2 of the License, or
+ ; (at your option) any later version.
+ ;
+ ; This program is distributed in the hope that it will be useful,
+ ; but WITHOUT ANY WARRANTY; without even the implied warranty of
+ ; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ ; GNU General Public License for more details.
+ ;
+ ; You should have received a copy of the GNU General Public License
+ ; along with this program; if not, write to the Free Software
+ ; Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+1 ;Demographic [DEM]
+ N W,Z,NODE
+ ;
+ ; -- name [1 - NM]
+ S VAX=^DPT(DFN,0),@VAV@($P(VAS,"^",1))=$P(VAX,"^")
+ ;
+ ; -- ssn [2 - SS]
+ S Z=$P(VAX,"^",9) S:Z]"" @VAV@($P(VAS,"^",2))=Z_$S(Z]"":"^"_$E(Z,1,3)_"-"_$E(Z,4,5)_"-"_$E(Z,6,10),1:"")
+ ;
+ ; -- date of birth [2 - DB]
+ S Z=$P(VAX,"^",3),Y=Z I Y]"" X ^DD("DD") S @VAV@($P(VAS,"^",3))=Z_"^"_Y
+ ;
+ ; -- age [4 - AG]
+ S W=$S('$D(^DPT(DFN,.35)):"",'^(.35):"",1:+^(.35)) S Y=$S('W:DT,1:W) S:Z]"" @VAV@($P(VAS,"^",4))=$E(Y,1,3)-$E(Z,1,3)-($E(Y,4,7)<$E(Z,4,7))
+ ;
+ ; Added for VOE to support pediatrics
+ ;
+ I @VAV@($P(VAS,"^",4))<2 D  ;IHS/ANMC/CLS 01/20/2005
+ .N X,X1,X2,X3
+ .S X1=$S('$G(^DPT(DFN,.35)):DT,1:+^(.35))
+ .S X2=$P(VAX,"^",3) Q:'X1!('X2)
+ .D ^%DTC S X3=X\365.25,X=$S(X3>2:X3,X<31:X_" DYS",1:X\30_" MOS")
+ .S @VAV@($P(VAS,"^",4))=X Q
+ ;
+ ; End VOE addition
+ ;
+ ;
+ ; -- expired date [6 - EX]
+ S (Y,Z)=W X:Y]"" ^DD("DD") S:Z]"" @VAV@($P(VAS,"^",6))=Z_"^"_Y
+ ;
+ ; -- sex [5 - SX]
+ S Z=$P(VAX,"^",2) S:Z]"" @VAV@($P(VAS,"^",5))=Z_"^"_$S(Z="M":"MALE",Z="F":"FEMALE",1:"") K Z
+ ;
+ ; -- remarks [7 - RE]
+ S @VAV@($P(VAS,"^",7))=$P(VAX,"^",10)
+ ;
+ ; -- historic race [8 - RA]
+ S Z=$P(VAX,"^",6),@VAV@($P(VAS,"^",8))=Z_$S($D(^DIC(10,+Z,0)):"^"_$P(^(0),"^"),1:"")
+ ;
+ ; -- religion [9 - RP]
+ S Z=$P(VAX,"^",8),@VAV@($P(VAS,"^",9))=Z_$S($D(^DIC(13,+Z,0)):"^"_$P(^(0),"^"),1:"")
+ ;
+ ; -- marital status [10 - MS]
+ S Z=$P(VAX,"^",5),@VAV@($P(VAS,"^",10))=Z_$S($D(^DIC(11,+Z,0)):"^"_$P(^(0),"^"),1:"")
+ ;
+ ; -- ethnicity [11 - ET]
+ S X=0 F Y=1:1 S X=+$O(^DPT(DFN,.06,X)) Q:'X  D
+ .S NODE=$G(^DPT(DFN,.06,X,0)),Z=$P(NODE,"^",1) I Z D
+ ..S @VAV@($P(VAS,"^",11),Y)=Z_"^"_$P($G(^DIC(10.2,Z,0)),"^",1)
+ ..; -- collection method
+ ..S Z=$P(NODE,"^",2) I Z D
+ ...S @VAV@($P(VAS,"^",11),Y,1)=Z_"^"_$P($G(^DIC(10.3,Z,0)),"^",1)
+ S @VAV@($P(VAS,"^",11))=Y-1
+ ;
+ ; -- race [12 - RC]
+ S X=0 F Y=1:1 S X=+$O(^DPT(DFN,.02,X)) Q:'X  D
+ .S NODE=$G(^DPT(DFN,.02,X,0)),Z=$P(NODE,"^",1) I Z D
+ ..S @VAV@($P(VAS,"^",12),Y)=Z_"^"_$P($G(^DIC(10,Z,0)),"^",1)
+ ..; -- collection method
+ ..S Z=$P(NODE,"^",2) I Z D
+ ...S @VAV@($P(VAS,"^",12),Y,1)=Z_"^"_$P($G(^DIC(10.3,Z,0)),"^",1)
+ S @VAV@($P(VAS,"^",12))=Y-1
+ Q
+ ;
+ ; Added for VOE to support pediatrics
+ ;
+PAGE ; -- IHS printable age  ;IHS/ITSC/CLS 01/14/2005
+ N X,X1,X2,Y,AUX
+ S X1=$S('$D(^DPT(DFN,.35)):DT,1:+^(.35))
+ S X2=$P(VAX,"^",3) D:X2 ^%DTC:X1 S AUX=X\365.25,X=$S(AUX>2:AUX_" YRS",X<31:X_" DYS",1:X\30_" MOS")
+ S @VAV@($P(VAS,"^",4))=X Q
+ ;
+ ; End addition for VOE & IHS
+ ;
+2 ;Other Patient Variables [OPD]
+ N W,Z
+ S VAX=^DPT(DFN,0)
+ ;
+ ; -- city of birth [1 - BC]
+ S @VAV@($P(VAS,"^",1))=$P(VAX,"^",11)
+ ;
+ ; -- state of birth [2 - BS]
+ S Z=$P(VAX,"^",12),@VAV@($P(VAS,"^",2))=Z_$S($D(^DIC(5,+Z,0)):"^"_$P(^(0),"^",1),1:"")
+ ;
+ ; -- occupation [6 - OC]
+ S @VAV@($P(VAS,"^",6))=$P(VAX,"^",7)
+ ;
+ ; -- names
+ S VAX=$S($D(^DPT(DFN,.24)):^(.24),1:"")
+ S @VAV@($P(VAS,"^",3))=$P(VAX,"^",1) ; father's        [3 - FN]
+ S @VAV@($P(VAS,"^",4))=$P(VAX,"^",2) ; mother's        [4 - MN]
+ S @VAV@($P(VAS,"^",5))=$P(VAX,"^",3) ; mother's maiden [5 - MM]
+ ;
+ ; -- employment status [7 - ES]
+ S VAX=$S($D(^DPT(DFN,.311)):^(.311),1:""),W="EMPLOYED FULL TIME^EMPLOYED PART TIME^NOT EMPLOYED^SELF EMPLOYED^RETIRED^ACTIVE MILITARY DUTY^UNKNOWN"
+ S Z=$P(VAX,"^",15),@VAV@($P(VAS,"^",7))=Z_$S(Z:"^"_$P(W,"^",Z),1:"")
+ Q
+ ;
+3 ;Address [ADD]
+ S VABEG=$S($D(VATEST("ADD",9)):VATEST("ADD",9),1:DT),VAEND=$S($D(VATEST("ADD",10)):VATEST("ADD",10),1:DT)
+ I $S($D(VAPA("P")):1,'$D(^DPT(DFN,.121)):1,$P(^(.121),"^",9)'="Y":1,'$P(^(.121),"^",7):1,$P(^(.121),"^",7)>VABEG:1,'$P(^(.121),"^",8):0,1:$P(^(.121),"^",8)<VAEND) S VAX=$S($D(^DPT(DFN,.11)):^(.11),1:""),VAX(1)=0
+ E  S VAX=$S($D(^DPT(DFN,.121)):^(.121),1:""),VAX(1)=1
+ F I=1:1:6 S VAZ=$P(VAX,"^",I),@VAV@($P(VAS,"^",I))=VAZ I I=5,$D(^DIC(5,+VAZ,0)) S VAZ=$P(^(0),"^"),@VAV@($P(VAS,"^",5))=@VAV@($P(VAS,"^",5))_"^"_VAZ
+ S VAZ=$S('VAX(1):$P(VAX,"^",7),1:$P(VAX,"^",11)) S:$D(^DIC(5,+$P(VAX,"^",5),1,+VAZ,0)) VAZ=VAZ_"^"_$P(^(0),"^",1) S @VAV@($P(VAS,"^",7))=VAZ
+ S VAZIP4=$P(VAX,U,12)
+ S @VAV@($P(VAS,U,11))=VAZIP4_$S('$G(VAZIP4):"",($L(VAZIP4)=5):U_VAZIP4,1:U_$E(VAZIP4,1,5)_"-"_$E(VAZIP4,6,9))
+ ;DG*5.3*516
+ I $D(^DPT(DFN,.13)) S @VAV@($P(VAS,"^",8))=$P(^(.13),"^",1)
+ I 'VAX(1) G CA
+ S @VAV@($P(VAS,"^",8))=$P(VAX,"^",10)
+ F I=7,8 S VAZ=$P(VAX,"^",I),Y=VAZ X:Y]"" ^DD("DD") S @VAV@($P(VAS,"^",I+2))=VAZ_"^"_Y
+CA ;Confidential Address
+ I '$D(^DPT(DFN,.141)) G Q3
+ N VACAT,VAACT,VAACTDT,VATYP,VATYPNAM,VACAN
+ S VAX=$S($D(^DPT(DFN,.141)):^(.141),1:"")
+ S VAACTDT=$S($D(VAPA("CD")):VAPA("CD"),1:DT)
+ F I=1:1:6 S VAZ=$P(VAX,"^",I),@VAV@($P(VAS,"^",I+12))=VAZ D
+ .I I=5,$D(^DIC(5,+VAZ,0)) S VAZ=$P(^(0),"^"),@VAV@($P(VAS,"^",I+12))=@VAV@($P(VAS,"^",I+12))_"^"_VAZ Q
+ .I I=6,($G(VAZ)]"") S @VAV@($P(VAS,"^",I+12))=@VAV@($P(VAS,"^",I+12))_"^"_$S(($L(VAZ)=5):VAZ,1:$E(VAZ,1,5)_"-"_$E(VAZ,6,9))
+ S VAZ=$P(VAX,"^",11) S:$D(^DIC(5,+$P(VAX,"^",5),1,+VAZ,0)) VAZ=VAZ_"^"_$P(^(0),"^",1) S @VAV@($P(VAS,"^",19))=VAZ
+ F I=7,8 S VAZ=$P(VAX,"^",I),Y=VAZ X:Y]"" ^DD("DD") S @VAV@($P(VAS,"^",I+13))=VAZ_"^"_Y
+ S VABEG=$P(VAX,"^",7),VAEND=$P(VAX,"^",8)
+ S @VAV@($P(VAS,"^",12))=1
+ I 'VABEG!(VABEG>VAACTDT)!(VAEND&(VAEND<VAACTDT)) S @VAV@($P(VAS,"^",12))=0
+ I $D(^DPT(DFN,.14)) D
+ .S VACAN="" F  S VACAN=$O(^DPT(DFN,.14,VACAN)) Q:VACAN=""  D
+ ..Q:'$D(^DPT(DFN,.14,VACAN,0))
+ ..S VATYP=$P(^DPT(DFN,.14,VACAN,0),"^",1),VAACT=$P(^DPT(DFN,.14,VACAN,0),"^",2)
+ ..S VACAT=$$GET1^DID(2.141,.01,"","POINTER","","DGERR")
+ ..S VATYPNAM="" F I=1:1 S VATYPNAM=$P(VACAT,";",I) Q:VATYPNAM=""  D
+ ...I +VATYPNAM[VATYP S VATYPNAM=$P(VATYPNAM,":",2),@VAV@($P(VAS,"^",22),VATYP)=VATYP_"^"_VATYPNAM_"^"_VAACT
+Q3 K VABEG,VAEND,VAZIP4 Q
+ ;
+4 ;Other Address [OAD]
+ N VAZIP4
+ I $S('$D(VAOA("A")):1,VAOA("A")<1:1,VAOA("A")>6:1,1:0) S VAX=.21,VAOA("A")=7
+ E  S VAX="."_$P("33^34^211^331^311^25","^",+VAOA("A"))
+ S VAX(1)=VAX,VAX=$S($D(^DPT(DFN,VAX(1))):^(VAX(1)),1:"") I VAX(1)=.25 S VAX=$P(VAX,"^",1)_"^^"_$P(VAX,"^",2,99)
+ S VAX(2)=0 F I=3,4,5,6,7,8 S VAX(2)=VAX(2)+1,@VAV@($P(VAS,"^",VAX(2)))=$P(VAX,"^",I)
+ S @VAV@($P(VAS,"^",7))="",@VAV@($P(VAS,"^",8))=$P(VAX,"^",9),VAX(2)=8
+ F I=1,2 S VAX(2)=VAX(2)+1,@VAV@($P(VAS,"^",VAX(2)))=$P(VAX,"^",I)
+ I "^.311^.25"[("^"_VAX(1)_"^") S @VAV@($P(VAS,"^",10))=""
+ S VAZ=@VAV@($P(VAS,"^",5)) I VAZ,$D(^DIC(5,+VAZ,0)) S VAZ(1)=$P(^(0),"^",1),@VAV@($P(VAS,"^",5))=VAZ_"^"_VAZ(1)
+ S VAZIP4=$P($G(^DPT(DFN,.22)),U,VAOA("A"))
+ S @VAV@($P(VAS,U,11))=VAZIP4_$S('$G(VAZIP4):"",($L(VAZIP4)=5):U_VAZIP4,1:U_$E(VAZIP4,1,5)_"-"_$E(VAZIP4,6,9))
+ Q
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT2.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT2.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT2.m	(revision 623)
@@ -1,60 +1,60 @@
-VADPT2	;ALB/MJK - ESTABLISH PATIENT VARIABLES ; 3/23/88  9:13 PM ; [10/20/95 4:02pm]
-	;;5.3;Registration;**69,749**;Aug 13, 1993;Build 10
-5	; -- INP call
-	S (VAWD,VATS,VADX,VAPP,VAAP,VARM)="" S VANOW=$$NOW^XLFDT K VAMV,VAMV0
-	I '$D(VAINDT) N VAINDT S VAINDT=VANOW
-	S VATD=9999999.999999-VAINDT
-	F VAID=VATD:0 S VAID=$O(^DGPM("APID",DFN,VAID)) Q:'VAID  S VAMV=$O(^(VAID,0)) D CHK I $D(VAMV) K:"^3^4^5^"[("^"_VAMT_"^") VAMV,VAMV0 Q
-	;
-	G:'$D(VAMV0) DONE
-	S (VAPRT,VAPRC,VACN)=1 D GET^VADPT30
-	S VAMV0=^DGPM(VAMV,0),VAMVT=$P(VAMV0,"^",4),VACA=$P(VAMV0,"^",14),VACA0=$S($D(^DGPM(+VACA,0)):^(0),1:"")
-	;
-	; set: adm ifn(1) ; doctor(2) ; tr spec(3) ; ward(4) ; room(5) ; attending (11)
-	S @VAV@($P(VAS,"^",1))=VACA,@VAV@($P(VAS,"^",2))=VAPP,@VAV@($P(VAS,"^",3))=VATS,@VAV@($P(VAS,"^",4))=VAWD,@VAV@($P(VAS,"^",5))=$P(VARM,"^",2),@VAV@($P(VAS,"^",11))=VAAP
-	;
-	; set bed/no bed  mvt type(6)
-	D IB S @VAV@($P(VAS,"^",6))=VAZ
-	;
-	; set adm date(7)
-	S Y=+VACA0 X:Y ^DD("DD") S @VAV@($P(VAS,"^",7))=+VACA0_"^"_Y
-	;
-	; set: adm type(8) ; adm dx(9) ; ptf ifn(10)
-	S @VAV@($P(VAS,"^",8))=$P(VACA0,"^",4)_"^"_$S($D(^DG(405.1,+$P(VACA0,"^",4),0)):$P(^(0),"^"),1:""),@VAV@($P(VAS,"^",9))=$P(VACA0,"^",10),@VAV@($P(VAS,"^",10))=$P(VACA0,"^",16)
-	;
-DONE	K VAID,VANOW,VACA,VACA0,VAMV,VAMV0,VATD,VAMT,VAMVT D KVAR^VADPT30 Q
-	;
-IB	;In-Bed status
-	; input:  VAINDT = internal date of requested info
-	;         VAMV   = starting IFN
-	;         VAMV0  = 0th of VAMV
-	;
-	; output: VAZ    = <O:not in bed OR 1: in bed>^fac. mvt name
-	;         VAZ(2) = abs ret date
-	;
-	S VAZ=0,VAZ(2)=""
-	S VAXI=+$O(^DGPM("APMV",DFN,+$P(VAMV0,"^",14),9999999.999999-VAINDT)),VAXI=+$O(^(VAXI,0))
-	I 'VAXI,$D(VAIP("L")),$P(VAMV0,"^",2)=4 S VAXI=VAMV ; only used via IN5
-	G IBQ:'VAXI
-	S VAX0=$S($D(^DGPM(VAXI,0)):^(0),1:"")
-	G IBQ:VAX0']"",IBQ:"^3^5^"[("^"_$P(VAX0,"^",2)_"^")
-	S VAXI=$S($D(^DG(405.1,+$P(VAX0,"^",4),0)):$P(^(0),"^"),1:"")
-	; -- check in-bed status flag
-	S VAZ=$S('$D(^DG(405.2,+$P(VAX0,"^",18),"E")):1,1:'^("E"))_"^"_VAXI,VAZ(2)=$P(VAX0,"^",13)
-IBQ	K VAXI,VAX0 Q
-	;
-CHK	; -- check if mvt exists and if 'while asih' type d/c
-	;    if VAMV returned undefined then continue $Oing
-	;
-	I $D(^DGPM(+VAMV,0)) S VAMV0=^(0),VAMT=$P(VAMV0,"^",2)
-	I '$D(VAMV0) K VAMV G CHKQ
-	I "^42^47^"[("^"_$P(VAMV0,"^",18)_"^"),$P(VAMV0,"^",22)'=2,$O(^DGPM("APMV",DFN,+$P(VAMV0,"^",14),VAID)),$O(^($O(^(VAID)),0)),$D(^DGPM($O(^(0)),0)),"^13^44^"[("^"_$P(^(0),"^",18)_"^") K VAMV,VAMV0
-	; info: 47 mvt can not have seq #; will always be null
-CHKQ	Q
-	;
-ADM	; -- send back adm ifn for dfn on vaindt or now
-	S VADT=$S($D(VAINDT):VAINDT,1:"") I 'VADT  S VADT=$$NOW^XLFDT
-	S VAID=9999999.999999-VADT,VADMVT=""
-	F  S VAID=$O(^DGPM("ATID1",DFN,VAID)) Q:'VAID  S VAMV=+$O(^DGPM("ATID1",DFN,VAID,0)) I $D(^DGPM(VAMV,0)) S VAMV0=^(0),VAMV1=$S($D(^DGPM(+$P(VAMV0,"^",17),0)):^(0),1:9999999.999999) D  Q:VADMVT!($P(VAMV0,U,18)'=40)
-	.I VAMV0'>VADT,VAMV1>VADT S VADMVT=VAMV
-	K VAID,VADT,VAMV,VAMV0,VAMV1
+VADPT2 ;ALB/MJK - ESTABLISH PATIENT VARIABLES ; 3/23/88  9:13 PM ; [10/20/95 4:02pm]
+ ;;5.3;Registration;**69**;Aug 13, 1993
+5 ; -- INP call
+ S (VAWD,VATS,VADX,VAPP,VAAP,VARM)="" D NOW^%DTC S VANOW=% K VAMV,VAMV0
+ I '$D(VAINDT) N VAINDT S VAINDT=VANOW
+ S VATD=9999999.999999-VAINDT
+ F VAID=VATD:0 S VAID=$O(^DGPM("APID",DFN,VAID)) Q:'VAID  S VAMV=$O(^(VAID,0)) D CHK I $D(VAMV) K:"^3^4^5^"[("^"_VAMT_"^") VAMV,VAMV0 Q
+ ;
+ G:'$D(VAMV0) DONE
+ S (VAPRT,VAPRC,VACN)=1 D GET^VADPT30
+ S VAMV0=^DGPM(VAMV,0),VAMVT=$P(VAMV0,"^",4),VACA=$P(VAMV0,"^",14),VACA0=$S($D(^DGPM(+VACA,0)):^(0),1:"")
+ ;
+ ; set: adm ifn(1) ; doctor(2) ; tr spec(3) ; ward(4) ; room(5) ; attending (11)
+ S @VAV@($P(VAS,"^",1))=VACA,@VAV@($P(VAS,"^",2))=VAPP,@VAV@($P(VAS,"^",3))=VATS,@VAV@($P(VAS,"^",4))=VAWD,@VAV@($P(VAS,"^",5))=$P(VARM,"^",2),@VAV@($P(VAS,"^",11))=VAAP
+ ;
+ ; set bed/no bed  mvt type(6)
+ D IB S @VAV@($P(VAS,"^",6))=VAZ
+ ;
+ ; set adm date(7)
+ S Y=+VACA0 X:Y ^DD("DD") S @VAV@($P(VAS,"^",7))=+VACA0_"^"_Y
+ ;
+ ; set: adm type(8) ; adm dx(9) ; ptf ifn(10)
+ S @VAV@($P(VAS,"^",8))=$P(VACA0,"^",4)_"^"_$S($D(^DG(405.1,+$P(VACA0,"^",4),0)):$P(^(0),"^"),1:""),@VAV@($P(VAS,"^",9))=$P(VACA0,"^",10),@VAV@($P(VAS,"^",10))=$P(VACA0,"^",16)
+ ;
+DONE K VAID,VANOW,VACA,VACA0,VAMV,VAMV0,VATD,VAMT,VAMVT D KVAR^VADPT30 Q
+ ;
+IB ;In-Bed status
+ ; input:  VAINDT = internal date of requested info
+ ;         VAMV   = starting IFN
+ ;         VAMV0  = 0th of VAMV
+ ;
+ ; output: VAZ    = <O:not in bed OR 1: in bed>^fac. mvt name
+ ;         VAZ(2) = abs ret date
+ ;
+ S VAZ=0,VAZ(2)=""
+ S VAXI=+$O(^DGPM("APMV",DFN,+$P(VAMV0,"^",14),9999999.999999-VAINDT)),VAXI=+$O(^(VAXI,0))
+ I 'VAXI,$D(VAIP("L")),$P(VAMV0,"^",2)=4 S VAXI=VAMV ; only used via IN5
+ G IBQ:'VAXI
+ S VAX0=$S($D(^DGPM(VAXI,0)):^(0),1:"")
+ G IBQ:VAX0']"",IBQ:"^3^5^"[("^"_$P(VAX0,"^",2)_"^")
+ S VAXI=$S($D(^DG(405.1,+$P(VAX0,"^",4),0)):$P(^(0),"^"),1:"")
+ ; -- check in-bed status flag
+ S VAZ=$S('$D(^DG(405.2,+$P(VAX0,"^",18),"E")):1,1:'^("E"))_"^"_VAXI,VAZ(2)=$P(VAX0,"^",13)
+IBQ K VAXI,VAX0 Q
+ ;
+CHK ; -- check if mvt exists and if 'while asih' type d/c
+ ;    if VAMV returned undefined then continue $Oing
+ ;
+ I $D(^DGPM(+VAMV,0)) S VAMV0=^(0),VAMT=$P(VAMV0,"^",2)
+ I '$D(VAMV0) K VAMV G CHKQ
+ I "^42^47^"[("^"_$P(VAMV0,"^",18)_"^"),$P(VAMV0,"^",22)'=2,$O(^DGPM("APMV",DFN,+$P(VAMV0,"^",14),VAID)),$O(^($O(^(VAID)),0)),$D(^DGPM($O(^(0)),0)),"^13^44^"[("^"_$P(^(0),"^",18)_"^") K VAMV,VAMV0
+ ; info: 47 mvt can not have seq #; will always be null
+CHKQ Q
+ ;
+ADM ; -- send back adm ifn for dfn on vaindt or now
+ S VADT=$S($D(VAINDT):VAINDT,1:"") I 'VADT D NOW^%DTC S VADT=%
+ S VAID=9999999.999999-VADT,VADMVT=""
+ F  S VAID=$O(^DGPM("ATID1",DFN,VAID)) Q:'VAID  S VAMV=+$O(^DGPM("ATID1",DFN,VAID,0)) I $D(^DGPM(VAMV,0)) S VAMV0=^(0),VAMV1=$S($D(^DGPM(+$P(VAMV0,"^",17),0)):^(0),1:9999999.999999) D  Q:VADMVT!($P(VAMV0,U,18)'=40)
+ .I VAMV0'>VADT,VAMV1>VADT S VADMVT=VAMV
+ K VAID,VADT,VAMV,VAMV0,VAMV1
Index: WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT3.m
===================================================================
--- WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT3.m	(revision 613)
+++ WorldVistAEHR/trunk/r/REGISTRATION-DGQE-DG-DPT-GRPX-VAD-VAF-VAS-VAT-VAU--VA-VIC--DGBT--DGJ--DGYA--VALM/VADPT3.m	(revision 623)
@@ -1,97 +1,97 @@
-VADPT3	;ALB/MRL - PATIENT VARIABLES [IN5]; 12 DEC 1988 ; 7/22/03 5:00pm
-	;;5.3;Registration;**532,749**;Aug 13, 1993;Build 10
-	;Inpatient variables [Version 5.0 and above]
-6	;
-	S (NOW,VAX("DAT"))=$$NOW^XLFDT,NOWI=9999999.999999-NOW
-	;
-	I $D(VAIP("E")),$D(^DGPM(+VAIP("E"),0)) S VAX("DT")=+^(0),E=+VAIP("E") G GO ;Specific Entry
-	;
-	I $D(VAIP("D")),"^l^L^"[("^"_$E(VAIP("D"))_"^") D LAST G GO:E,Q
-	;
-	S VAX=$S($D(VAIP("D")):VAIP("D"),$D(VAINDT):VAINDT,1:0)
-	I VAX S:VAX?7N!(VAX?7N1".".N) VAX("DT")=VAX I '$D(VAX("DT")) G Q ;Invalid Entry
-	;
-	S:'$D(VAX("DT")) VAX("DT")=NOW
-	I VAX("DT")=VAX("DAT") S E=$S($D(^DPT(DFN,.102)):+^(.102),1:0),E=$S($D(^DGPM(E,0)):E,1:0) G GO:E D LODGER G GO:E D ASIHOF G GO:E,Q ;Current IP
-	;
-	;Find Past Movement
-	S VAX=+$O(^DGPM("APID",DFN,9999999.999999-VAX("DT"))) I 'VAX D LODGER G GO:E,Q
-	S VAX=+$O(^DGPM("APID",DFN,VAX,0)) I '$D(^DGPM(VAX,0)) D LODGER G GO:E,Q
-	S VAZ=^DGPM(VAX,0) D OK G GO:E D LODGER G GO:E,Q
-	;
-GO	S:'$D(VAX("DT")) VAX("DT")=NOW D ^VADPT31 ; setting of VAX("DT") can be removed??
-	;
-Q	K NOW,NOWI,VAX,VAZ,VAZ2,E,VACC,VAQ,VANN,VASET,^UTILITY("VADPTZ",$J,DFN) D KVAR^VADPT30 Q
-	;
-OK	N VAADT,VADDT,VAQUIT
-	S E=0,VAZ2="^"_(+$P(VAZ,"^",18))_"^"
-	I "^13^41^46^"[VAZ2 D OK1 Q:'VAX  G OK
-	I "^42^"[VAZ2 D 42 I 'Y D OK1 Q:'VAX  G OK
-	I "^47^"[VAZ2 D 47 I 'Y D OK1 Q:'VAX  G OK
-	I $D(VAX("DT")),$P(VAZ,"^",2)=3,VAZ'>VAX("DT") Q
-	;DG*5.3*532
-	;Check for out-of-order disch. recs caused by same day adm./disch.
-	;where disch. date < adm. date because disch. date had no time
-	I +VAZ<2890000,$D(VAX("DT")),$P(VAZ,"^",2)'=3 S VAQUIT=0 D  Q:VAQUIT
-	.S VAADT=$P(VAZ,"^",14) Q:'VAADT
-	.S VADDT=$P($G(^DGPM(VAADT,0)),"^",17) Q:'VADDT
-	.S VADDT=$P($G(^DGPM(VADDT,0)),"^",14) I $P(VADDT,".",2)="",VADDT=$P(VAADT,"."),VAZ'>VAX("DT") S VAQUIT=1
-	S E=+VAX Q
-	;
-OK1	S VAX=+$O(^DGPM("APID",DFN,9999999.9999999-(VAZ+($P(VAZ,"^",22)/10000000)))),VAX=+$O(^(VAX,0))
-	I VAX,$D(^DGPM(VAX,0)) S VAZ=^(0)
-	Q
-	;
-LAST	; returns last movement for patient
-	; called by bed control and pt inquiry
-	S VAX=+$O(^DGPM("APID",DFN,NOWI)),E=0
-	I $D(VAIP("L")) D LLDCHK G LASTQ:E
-	S VAX=+$O(^DGPM("APID",DFN,VAX,0)) I $D(^DGPM(VAX,0)) S VAZ=^(0) D OK
-LASTQ	S VAX("DT")=NOW
-	Q
-	;
-LODGER	;
-	S E=0 G LODGERQ:'$D(VAIP("L"))
-	I VAX("DT")=VAX("DAT") S VAX=$S($D(^DPT(DFN,.107)):^(.107),1:"") G LODGERQ:VAX']"" S E=$S($D(^DPT("LD",VAX,DFN)):+^(DFN),1:0) G LODGERQ
-	;
-	S VAX=$O(^DGPM("ATID4",DFN,9999999.999999-VAX("DT"))) S:VAX E=+$O(^DGPM("ATID4",DFN,VAX,0))
-	I E S E=$S($D(^DGPM(E,0)):E,1:0) I E,$D(^DGPM(+$P(^(0),"^",17),0)),^(0)'>VAX("DT") S E=0
-LODGERQ	Q
-	;
-LLDCHK	; -- last lodger mvt checking ; build array of inverse dates and chk
-	N IDT S IDT(VAX)=0
-	S IDT=+$O(^DGPM("ATID4",DFN,NOWI)) S:IDT IDT(IDT)=+$O(^(IDT,0))
-	S IDT=+$O(^DGPM("ATID5",DFN,NOWI)) S:IDT IDT(IDT)=+$O(^(IDT,0))
-	S IDT=+$O(IDT(0)) I IDT S E=IDT(IDT),E=$S($D(^DGPM(E,0)):E,1:0)
-	Q
-	; 
-CHK	;
-	G VAR^VADPT30
-	;
-ASIHOF	; -- is last mvt asih oth fac
-	S E=0,VAX=$S('$O(^DGPM("APID",DFN,NOWI)):"",1:$O(^DGPM("APID",DFN,$O(^(NOWI)),0)))
-	I VAX,$D(^DGPM(VAX,0)),"^43^45^"[("^"_$P(^(0),"^",18)_"^") S E=VAX
-	Q
-	;
-42	; -- check to see if this mvt can be used; for 'while asih' d/c category
-	;   If Y returned high then mvt is good
-	;
-	I VAZ'<VAX("DAT") S Y=0 G Q42 ; not a real d/c yet
-	I $P(VAZ,"^",22)=2 S Y=0 G Q42 ; nhcu d/c assoicated w/asih d/c (seq #2)
-	D SCAN
-Q42	Q
-	;
-SCAN	; -- determine is d/c while in other fac(Y=1 returned if so.)
-	;
-	N VAID,VACA,M S Y=0,VAID=9999999.999999-VAZ,VACA=+$P(VAZ,"^",14)
-	F VAID=VAID:0 S VAID=$O(^DGPM("APMV",DFN,VACA,VAID)) Q:'VAID  I $D(^DGPM(+$O(^(VAID,0)),0)) S M=$P(^(0),"^",18) I "^13^44^43^45^"[("^"_M_"^") S Y=$S(M=43!(M=45):1,1:0) Q
-	Q
-	;
-47	; -- check to see if d/c from nhcu while asih in other fac
-	;   If y returned high then mvt is good.
-	D SCAN Q
-	;
-	; 13 = to asih (vah)     (xfr)|44 = resume asih in parent facility (xfr)
-	; 41 = from asih         (d/c)|45 = change asih location(other fac)(xfr)
-	; 42 = while asih        (d/c)|46 = continues asih (other fac)     (d/c)
-	; 43 = to asih(other fac)(xfr)|47 = discharge from nhcu while asih (d/c)
+VADPT3 ;ALB/MRL - PATIENT VARIABLES [IN5]; 12 DEC 1988 ; 7/22/03 5:00pm
+ ;;5.3;Registration;**532**;Aug 13, 1993
+ ;Inpatient variables [Version 5.0 and above]
+6 ;
+ D NOW^%DTC S (NOW,VAX("DAT"))=%,NOWI=9999999.999999-%
+ ;
+ I $D(VAIP("E")),$D(^DGPM(+VAIP("E"),0)) S VAX("DT")=+^(0),E=+VAIP("E") G GO ;Specific Entry
+ ;
+ I $D(VAIP("D")),"^l^L^"[("^"_$E(VAIP("D"))_"^") D LAST G GO:E,Q
+ ;
+ S VAX=$S($D(VAIP("D")):VAIP("D"),$D(VAINDT):VAINDT,1:0)
+ I VAX S:VAX?7N!(VAX?7N1".".N) VAX("DT")=VAX I '$D(VAX("DT")) G Q ;Invalid Entry
+ ;
+ S:'$D(VAX("DT")) VAX("DT")=NOW
+ I VAX("DT")=VAX("DAT") S E=$S($D(^DPT(DFN,.102)):+^(.102),1:0),E=$S($D(^DGPM(E,0)):E,1:0) G GO:E D LODGER G GO:E D ASIHOF G GO:E,Q ;Current IP
+ ;
+ ;Find Past Movement
+ S VAX=+$O(^DGPM("APID",DFN,9999999.999999-VAX("DT"))) I 'VAX D LODGER G GO:E,Q
+ S VAX=+$O(^DGPM("APID",DFN,VAX,0)) I '$D(^DGPM(VAX,0)) D LODGER G GO:E,Q
+ S VAZ=^DGPM(VAX,0) D OK G GO:E D LODGER G GO:E,Q
+ ;
+GO S:'$D(VAX("DT")) VAX("DT")=NOW D ^VADPT31 ; setting of VAX("DT") can be removed??
+ ;
+Q K NOW,NOWI,VAX,VAZ,VAZ2,E,VACC,VAQ,VANN,VASET,^UTILITY("VADPTZ",$J,DFN) D KVAR^VADPT30 Q
+ ;
+OK N VAADT,VADDT,VAQUIT
+ S E=0,VAZ2="^"_(+$P(VAZ,"^",18))_"^"
+ I "^13^41^46^"[VAZ2 D OK1 Q:'VAX  G OK
+ I "^42^"[VAZ2 D 42 I 'Y D OK1 Q:'VAX  G OK
+ I "^47^"[VAZ2 D 47 I 'Y D OK1 Q:'VAX  G OK
+ I $D(VAX("DT")),$P(VAZ,"^",2)=3,VAZ'>VAX("DT") Q
+ ;DG*5.3*532
+ ;Check for out-of-order disch. recs caused by same day adm./disch.
+ ;where disch. date < adm. date because disch. date had no time
+ I +VAZ<2890000,$D(VAX("DT")),$P(VAZ,"^",2)'=3 S VAQUIT=0 D  Q:VAQUIT
+ .S VAADT=$P(VAZ,"^",14) Q:'VAADT
+ .S VADDT=$P($G(^DGPM(VAADT,0)),"^",17) Q:'VADDT
+ .S VADDT=$P($G(^DGPM(VADDT,0)),"^",14) I $P(VADDT,".",2)="",VADDT=$P(VAADT,"."),VAZ'>VAX("DT") S VAQUIT=1
+ S E=+VAX Q
+ ;
+OK1 S VAX=+$O(^DGPM("APID",DFN,9999999.9999999-(VAZ+($P(VAZ,"^",22)/10000000)))),VAX=+$O(^(VAX,0))
+ I VAX,$D(^DGPM(VAX,0)) S VAZ=^(0)
+ Q
+ ;
+LAST ; returns last movement for patient
+ ; called by bed control and pt inquiry
+ S VAX=+$O(^DGPM("APID",DFN,NOWI)),E=0
+ I $D(VAIP("L")) D LLDCHK G LASTQ:E
+ S VAX=+$O(^DGPM("APID",DFN,VAX,0)) I $D(^DGPM(VAX,0)) S VAZ=^(0) D OK
+LASTQ S VAX("DT")=NOW
+ Q
+ ;
+LODGER ;
+ S E=0 G LODGERQ:'$D(VAIP("L"))
+ I VAX("DT")=VAX("DAT") S VAX=$S($D(^DPT(DFN,.107)):^(.107),1:"") G LODGERQ:VAX']"" S E=$S($D(^DPT("LD",VAX,DFN)):+^(DFN),1:0) G LODGERQ
+ ;
+ S VAX=$O(^DGPM("ATID4",DFN,9999999.999999-VAX("DT"))) S:VAX E=+$O(^DGPM("ATID4",DFN,VAX,0))
+ I E S E=$S($D(^DGPM(E,0)):E,1:0) I E,$D(^DGPM(+$P(^(0),"^",17),0)),^(0)'>VAX("DT") S E=0
+LODGERQ Q
+ ;
+LLDCHK ; -- last lodger mvt checking ; build array of inverse dates and chk
+ N IDT S IDT(VAX)=0
+ S IDT=+$O(^DGPM("ATID4",DFN,NOWI)) S:IDT IDT(IDT)=+$O(^(IDT,0))
+ S IDT=+$O(^DGPM("ATID5",DFN,NOWI)) S:IDT IDT(IDT)=+$O(^(IDT,0))
+ S IDT=+$O(IDT(0)) I IDT S E=IDT(IDT),E=$S($D(^DGPM(E,0)):E,1:0)
+ Q
+ ; 
+CHK ;
+ G VAR^VADPT30
+ ;
+ASIHOF ; -- is last mvt asih oth fac
+ S E=0,VAX=$S('$O(^DGPM("APID",DFN,NOWI)):"",1:$O(^DGPM("APID",DFN,$O(^(NOWI)),0)))
+ I VAX,$D(^DGPM(VAX,0)),"^43^45^"[("^"_$P(^(0),"^",18)_"^") S E=VAX
+ Q
+ ;
+42 ; -- check to see if this mvt can be used; for 'while asih' d/c category
+ ;   If Y returned high then mvt is good
+ ;
+ I VAZ'<VAX("DAT") S Y=0 G Q42 ; not a real d/c yet
+ I $P(VAZ,"^",22)=2 S Y=0 G Q42 ; nhcu d/c assoicated w/asih d/c (seq #2)
+ D SCAN
+Q42 Q
+ ;
+SCAN ; -- determine is d/c while in other fac(Y=1 returned if so.)
+ ;
+ N VAID,VACA,M S Y=0,VAID=9999999.999999-VAZ,VACA=+$P(VAZ,"^",14)
+ F VAID=VAID:0 S VAID=$O(^DGPM("APMV",DFN,VACA,VAID)) Q:'VAID  I $D(^DGPM(+$O(^(VAID,0)),0)) S M=$P(^(0),"^",18) I "^13^44^43^45^"[("^"_M_"^") S Y=$S(M=43!(M=45):1,1:0) Q
+ Q
+ ;
+47 ; -- check to see if d/c from nhcu while asih in other fac
+ ;   If y returned high then mvt is good.
+ D SCAN Q
+ ;
+ ; 13 = to asih (vah)     (xfr)|44 = resume asih in parent facility (xfr)
+ ; 41 = from asih         (d/c)|45 = change asih location(other fac)(xfr)
+ ; 42 = while asih        (d/c)|46 = continues asih (other fac)     (d/c)
+ ; 43 = to asih(other fac)(xfr)|47 = discharge from nhcu while asih (d/c)
